#include <math.h>
#include "lisp.h"

Pointer array(size_t size) {
  Pointer ptr = memory_new(ARRAY, sizeof(Array) + size * sizeof(Pointer));
  ARRAY(ptr).length = 0;
  ARRAY(ptr).size = size;
  return ptr;
}

Pointer array_push(Pointer pArray, Pointer pData) {
  Array* array = &ARRAY(pArray);
  if (array->size == array->length) {
    array->size = MAX(array->size * 2, 1);
    pArray = memory_resize(pArray, sizeof(Array) + array->size * sizeof(Pointer));
    array = &ARRAY(pArray);
  }

  array->data[array->length++] = pData;
  return pArray;
}

Pointer array_pop(Pointer pArray) {
  Array* array = &ARRAY(pArray);
  if (array->length == 0) {
    return NIL;
  }
  return array->data[--array->length];
}

Pointer array_set(Pointer pArray, size_t i, Pointer data) {
  Array* array = &ARRAY(pArray);
  if (array->size <= i) {
    array->size = MAX(array->size * 2, 1);
    while (array->size <= i) {
      array->size = array->size * 2;
    }
    pArray = memory_resize(pArray, sizeof(Array) + array->size * sizeof(Pointer));
    array = &ARRAY(pArray);
    while (array->length < i) {
      array->data[array->length++] = UNDEFINED;
    }
  }
  array->length++;
  array->data[i] = data;
  return pArray;
}

Pointer array_get(Pointer pArray, size_t i) {
  Array* array = &ARRAY(pArray);
  if (array->length <= i) {
    return UNDEFINED;
  }

  return array->data[i];
}

size_t array_length(Pointer array) {
  return ARRAY(array).length;
}
