#include "lisp.h"

Pointer cons(Pointer car, Pointer cdr) {
  Pointer ptr = memory_new(CONS, sizeof(Cons));     
  Cons* cons = &CONS(ptr);
  cons->car = car;
  cons->cdr = cdr;
  return ptr;
}


Pointer reduce_fn(Pointer args, Pointer env) {
  Pointer list = CAR(args);
  Pointer reducer = CAR(CDR(args));
  Pointer previous = CAR(CDR(CDR(args)));
  REDUCE(list, eval_fn(LIST(reducer, previous, CAR(list)), env), previous);
  return previous;
}

Pointer cons_fn(Pointer args, Pointer env) {
  (void) env;
  return cons(CAR(args), CAR(CDR(args)));
}

Pointer car_fn(Pointer args, Pointer env) {
  (void) env;
  return CAR(CAR(args));
}

Pointer cdr_fn(Pointer args, Pointer env) {
  (void) env;
  return CDR(CAR(args));
}

Pointer list_fn(Pointer args, Pointer env) {
  (void) env;
  return args;
}
