#include "lisp.h"

static Pointer GLOBALS;

Pointer environment_get(Pointer env, Pointer key) {
  while (env != NIL) {
    Pointer value = table_get(CAR(env), key);
    if (value != UNDEFINED) {
      return value;
    }
    env = CDR(env);
  }

  return table_get(GLOBALS, key);
}

Pointer environment_set(Pointer env, Pointer key, Pointer value) {
  while (env != NIL) {
    if (table_get(CAR(env), key) != UNDEFINED) {
      CONS(env).car = table_set(CAR(env), key, value);
      return value;
    }
    env = CDR(env);
  }

  GLOBALS = table_set(GLOBALS, key, value);
  return key;
}

void environment_init(void) {
  GLOBALS = table(1);
}
