#include <string.h>
#include "lisp.h"

Pointer NIL;
Pointer T;
Pointer STANDARD_INPUT;
Pointer STANDARD_OUTPUT;
Pointer UNDEFINED;
Pointer BODY;
Pointer REST;

static Pointer SYMBOLS;

Pointer symbol(char* string, size_t length) {
  Symbol* symbol;
  bool matching = false;
  Pointer pointer = -1;

  Array* symbols = &ARRAY(SYMBOLS);
  for (size_t i = 0; i < symbols->length; i++) {
    pointer = array_get(SYMBOLS, i);
    symbol = &SYMBOL(pointer);
    if (symbol->length != length)  {
      continue;
    }

    matching = true;
    for (unsigned j = 0; j < length; j++) {
      if (symbol->data[j] != string[j]) {
	matching = false;
	break;
      }
    }

    if (matching) {
      return pointer;
    }
  }

  pointer = memory_new(SYMBOL, sizeof(Symbol) + length);
  SYMBOLS = array_push(SYMBOLS, pointer);
  symbol = &SYMBOL(pointer);
  symbol->length = length;
  for (unsigned i = 0; i < length; i++) {
    symbol->data[i] = string[i];
  }

  return pointer;
}

void symbol_init(void) {
  SYMBOLS = array(2);
  NIL = symbol1("nil");
  T = symbol1("t");
  STANDARD_INPUT = symbol1("*standard-input*");
  STANDARD_OUTPUT = symbol1("*standard-output*");
  UNDEFINED = symbol1("undefined");
  BODY = symbol1("&body");
  REST = symbol1("&rest");
}

