#include "ptlisp-test.h"
#include "../src/lisp.h"

int main(void) {
  SRunner *sr = srunner_create(make_memory_test_suite());
  int nf;

  srunner_add_suite(sr, make_array_test_suite());
  srunner_add_suite(sr, make_table_test_suite());
  srunner_add_suite(sr, make_symbol_test_suite());
  srunner_add_suite(sr, make_string_test_suite());
  srunner_add_suite(sr, make_cons_test_suite());
  srunner_add_suite(sr, make_environment_test_suite());
  srunner_add_suite(sr, make_evaluator_test_suite());
  srunner_add_suite(sr, make_lisp_test_suite());
  srunner_add_suite(sr, make_reader_test_suite());
  srunner_add_suite(sr, make_printer_test_suite());

  /* srunner_set_fork_status(sr, CK_NOFORK); */
  srunner_run_all(sr, CK_NORMAL);
  nf = srunner_ntests_failed(sr);
  srunner_free(sr);
  
  return nf == 0 ? 0 : 1;
}
